/* port address of internal registers */

#define SMR0	(*(volatile unsigned char *)0xffff81a0)
#define BRR0	(*(volatile unsigned char *)0xffff81a1)
#define SCR0	(*(volatile unsigned char *)0xffff81a2)
#define TDR0	(*(volatile unsigned char *)0xffff81a3)
#define SSR0	(*(volatile unsigned char *)0xffff81a4)
#define RDR0	(*(volatile unsigned char *)0xffff81a5)
#define SMR1	(*(volatile unsigned char *)0xffff81b0)
#define BRR1	(*(volatile unsigned char *)0xffff81b1)
#define SCR1	(*(volatile unsigned char *)0xffff81b2)
#define TDR1	(*(volatile unsigned char *)0xffff81b3)
#define SSR1	(*(volatile unsigned char *)0xffff81b4)
#define RDR1	(*(volatile unsigned char *)0xffff81b5)
#define SMR2	(*(volatile unsigned char *)0xffff81c0)
#define BRR2	(*(volatile unsigned char *)0xffff81c1)
#define SCR2	(*(volatile unsigned char *)0xffff81c2)
#define TDR2	(*(volatile unsigned char *)0xffff81c3)
#define SSR2	(*(volatile unsigned char *)0xffff81c4)
#define RDR2	(*(volatile unsigned char *)0xffff81c5)

#define TCR3	(*(volatile unsigned char *)0xffff8200)
#define TCR4	(*(volatile unsigned char *)0xffff8201)
#define TMDR3	(*(volatile unsigned char *)0xffff8202)
#define TMDR4	(*(volatile unsigned char *)0xffff8203)
#define TIOR3H	(*(volatile unsigned char *)0xffff8204)
#define TIOR3L	(*(volatile unsigned char *)0xffff8205)
#define TIOR4H	(*(volatile unsigned char *)0xffff8206)
#define TIOR4L	(*(volatile unsigned char *)0xffff8207)
#define TIER3	(*(volatile unsigned char *)0xffff8208)
#define TIER4	(*(volatile unsigned char *)0xffff8209)
#define TOER	(*(volatile unsigned char *)0xffff820a)
#define TOCR	(*(volatile unsigned char *)0xffff820b)
#define TGCR	(*(volatile unsigned char *)0xffff820d)
#define TCNT3	(*(volatile unsigned short *)0xffff8210)
#define TCNT4	(*(volatile unsigned short *)0xffff8212)
#define TCDR	(*(volatile unsigned short *)0xffff8214)
#define TDDR	(*(volatile unsigned short *)0xffff8216)
#define TGR3A	(*(volatile unsigned short *)0xffff8218)
#define TGR3B	(*(volatile unsigned short *)0xffff821a)
#define TGR4A	(*(volatile unsigned short *)0xffff821c)
#define TGR4B	(*(volatile unsigned short *)0xffff821e)
#define TCNTS	(*(volatile unsigned short *)0xffff8220)
#define TCBR	(*(volatile unsigned short *)0xffff8222)
#define TGR3C	(*(volatile unsigned short *)0xffff8224)
#define TGR3D	(*(volatile unsigned short *)0xffff8226)
#define TGR4C	(*(volatile unsigned short *)0xffff8228)
#define TGR4D	(*(volatile unsigned short *)0xffff822a)
#define TSR3	(*(volatile unsigned char *)0xffff822c)
#define TSR4	(*(volatile unsigned char *)0xffff822d)
#define TSTR	(*(volatile unsigned char *)0xffff8240)
#define TSYR	(*(volatile unsigned char *)0xffff8241)
#define TCR0	(*(volatile unsigned char *)0xffff8260)
#define TMDR0	(*(volatile unsigned char *)0xffff8261)
#define TIOR0H	(*(volatile unsigned char *)0xffff8262)
#define TIOR0L	(*(volatile unsigned char *)0xffff8263)
#define TIER0	(*(volatile unsigned char *)0xffff8264)
#define TSR0	(*(volatile unsigned char *)0xffff8265)
#define TCNT0	(*(volatile unsigned short *)0xffff8266)
#define TGR0A	(*(volatile unsigned short *)0xffff8268)
#define TGR0B	(*(volatile unsigned short *)0xffff826a)
#define TGR0C	(*(volatile unsigned short *)0xffff826c)
#define TGR0D	(*(volatile unsigned short *)0xffff826e)
#define TCR1	(*(volatile unsigned char *)0xffff8280)
#define TMDR1	(*(volatile unsigned char *)0xffff8281)
#define TIOR1	(*(volatile unsigned char *)0xffff8282)
#define TIER1	(*(volatile unsigned char *)0xffff8284)
#define TSR1	(*(volatile unsigned char *)0xffff8285)
#define TCNT1	(*(volatile unsigned short *)0xffff8286)
#define TGR1A	(*(volatile unsigned short *)0xffff8288)
#define TGR1B	(*(volatile unsigned short *)0xffff828a)
#define TCR2	(*(volatile unsigned char *)0xffff82a0)
#define TMDR2	(*(volatile unsigned char *)0xffff82a1)
#define TIOR2	(*(volatile unsigned char *)0xffff82a2)
#define TIER2	(*(volatile unsigned char *)0xffff82a4)
#define TSR2	(*(volatile unsigned char *)0xffff82a5)
#define TCNT2	(*(volatile unsigned short *)0xffff82a6)
#define TGR2A	(*(volatile unsigned short *)0xffff82a8)
#define TGR2B	(*(volatile unsigned short *)0xffff82aa)

#define IPRA	(*(volatile unsigned short *)0xffff8348)
#define IPRB	(*(volatile unsigned short *)0xffff834a)
#define IPRC	(*(volatile unsigned short *)0xffff834c)
#define IPRD	(*(volatile unsigned short *)0xffff834e)
#define IPRE	(*(volatile unsigned short *)0xffff8350)
#define IPRF	(*(volatile unsigned short *)0xffff8352)
#define IPRG	(*(volatile unsigned short *)0xffff8354)
#define IPRH	(*(volatile unsigned short *)0xffff8356)
#define ICR	(*(volatile unsigned short *)0xffff8358)
#define ISR	(*(volatile unsigned short *)0xffff835a)

#define PADRH	(*(volatile unsigned short *)0xffff8380)
#define PADRL	(*(volatile unsigned short *)0xffff8382)
#define PAIORH	(*(volatile unsigned short *)0xffff8384)
#define PAIORL	(*(volatile unsigned short *)0xffff8386)
#define PACRH	(*(volatile unsigned short *)0xffff8388)
#define PACRL1	(*(volatile unsigned short *)0xffff838c)
#define PACRL2	(*(volatile unsigned short *)0xffff838e)
#define PBDR	(*(volatile unsigned short *)0xffff8390)
#define PCDR	(*(volatile unsigned short *)0xffff8392)
#define PBIOR	(*(volatile unsigned short *)0xffff8394)
#define PCIOR	(*(volatile unsigned short *)0xffff8396)
#define PBCR1	(*(volatile unsigned short *)0xffff8398)
#define PBCR2	(*(volatile unsigned short *)0xffff839a)
#define PCCR	(*(volatile unsigned short *)0xffff839c)
#define PDDRH	(*(volatile unsigned short *)0xffff83a0)
#define PDDRL	(*(volatile unsigned short *)0xffff83a2)
#define PDIORH	(*(volatile unsigned short *)0xffff83a4)
#define PDIORL	(*(volatile unsigned short *)0xffff83a6)
#define PDCRH1	(*(volatile unsigned short *)0xffff83a8)
#define PDCRH2	(*(volatile unsigned short *)0xffff83aa)
#define PDCRL	(*(volatile unsigned short *)0xffff83ac)
#define PEDR	(*(volatile unsigned short *)0xffff83b0)
#define PFDR	(*(volatile unsigned short *)0xffff83b2)
#define PEIOR	(*(volatile unsigned short *)0xffff83b4)
#define PECR1	(*(volatile unsigned short *)0xffff83b8)
#define PECR2	(*(volatile unsigned short *)0xffff83ba)

#define ICSR	(*(volatile unsigned short *)0xffff83c0)
#define OCSR	(*(volatile unsigned short *)0xffff83c2)
#define IFSR	(*(volatile unsigned short *)0xffff83c8)
#define CMSTR	(*(volatile unsigned short *)0xffff83d0)
#define CMCSR0	(*(volatile unsigned short *)0xffff83d2)
#define CMCNT0	(*(volatile unsigned short *)0xffff83d4)
#define CMCOR0	(*(volatile unsigned short *)0xffff83d6)
#define CMCSR1	(*(volatile unsigned short *)0xffff83d8)
#define CMCNT1	(*(volatile unsigned short *)0xffff83da)
#define CMCOR1	(*(volatile unsigned short *)0xffff83dc)

#define ADCSR	(*(volatile unsigned char *)0xffff83e0)
#define ADCR	(*(volatile unsigned char *)0xffff83e1)
#define ADDRA	(*(volatile unsigned short *)0xffff83f0)
#define ADDRB	(*(volatile unsigned short *)0xffff83f2)
#define ADDRC	(*(volatile unsigned short *)0xffff83f4)
#define ADDRD	(*(volatile unsigned short *)0xffff83f6)
#define ADDRE	(*(volatile unsigned short *)0xffff83f8)
#define ADDRF	(*(volatile unsigned short *)0xffff83fa)
#define ADDRG	(*(volatile unsigned short *)0xffff83fc)
#define ADDRH	(*(volatile unsigned short *)0xffff83fe)
#define ADDRA0	(*(volatile unsigned short *)0xffff8400)
#define ADDRB0	(*(volatile unsigned short *)0xffff8402)
#define ADDRC0	(*(volatile unsigned short *)0xffff8404)
#define ADDRD0	(*(volatile unsigned short *)0xffff8406)
#define ADDRA1	(*(volatile unsigned short *)0xffff8408)
#define ADDRB1	(*(volatile unsigned short *)0xffff840a)
#define ADDRC1	(*(volatile unsigned short *)0xffff840c)
#define ADDRD1	(*(volatile unsigned short *)0xffff840e)
#define ADCSR0	(*(volatile unsigned char *)0xffff8410)
#define ADCSR1	(*(volatile unsigned char *)0xffff8411)
#define AADCR0	(*(volatile unsigned char *)0xffff8412)
#define AADCR1	(*(volatile unsigned char *)0xffff8413)

#define FLMCR1	(*(volatile unsigned char *)0xffff8580)
#define FLMCR2	(*(volatile unsigned char *)0xffff8581)
#define EBR1	(*(volatile unsigned char *)0xffff8582)
#define EBR2	(*(volatile unsigned char *)0xffff8583)

#define TCSR_WR	(*(volatile unsigned short *)0xffff8610)
#define TCSR_RD	(*(volatile unsigned char *)0xffff8610)
#define TCNT_WR	(*(volatile unsigned short *)0xffff8610)
#define TCNT_RD	(*(volatile unsigned char *)0xffff8611)
#define RSTSCR_WR (*(volatile unsigned short *)0xffff8612)
#define RSTSCR_RD (*(volatile unsigned char *)0xffff8613)
#define SBYCR	(*(volatile unsigned char *)0xffff8614)

#define BCR1	(*(volatile unsigned short *)0xffff8620)
#define BCR2	(*(volatile unsigned short *)0xffff8622)
#define WCR1	(*(volatile unsigned short *)0xffff8624)
#define WCR2	(*(volatile unsigned short *)0xffff8626)
#define RAMER	(*(volatile unsigned short *)0xffff8628)
#define DCR	(*(volatile unsigned short *)0xffff862a)
#define RTCSR	(*(volatile unsigned short *)0xffff862c)
#define RTCNT	(*(volatile unsigned short *)0xffff862e)
#define RTCOR	(*(volatile unsigned short *)0xffff8630)
#define DMAOR	(*(volatile unsigned short *)0xffff86b0)

#define SAR0	(*(volatile unsigned int *)0xffff86c0)
#define DAR0	(*(volatile unsigned int *)0xffff86c4)
#define DAMATCR0 (*(volatile unsigned int *)0xffff86c8)
#define CHCR0	(*(volatile unsigned int *)0xffff86cc)
#define SAR1	(*(volatile unsigned int *)0xffff86d0)
#define DAR1	(*(volatile unsigned int *)0xffff86d4)
#define DAMATCR1 (*(volatile unsigned int *)0xffff86d8)
#define CHCR1	(*(volatile unsigned int *)0xffff86dc)
#define SAR2	(*(volatile unsigned int *)0xffff86e0)
#define DAR2	(*(volatile unsigned int *)0xffff86e4)
#define DAMATCR2 (*(volatile unsigned int *)0xffff86e8)
#define CHCR2	(*(volatile unsigned int *)0xffff86ec)
#define SAR3	(*(volatile unsigned int *)0xffff86f0)
#define DAR3	(*(volatile unsigned int *)0xffff86f4)
#define DAMATCR3 (*(volatile unsigned int *)0xffff86f8)
#define CHCR3	(*(volatile unsigned int *)0xffff86fc)

#define DTEA	(*(volatile unsigned char *)0xffff8700)
#define DTEB	(*(volatile unsigned char *)0xffff8701)
#define DTEC	(*(volatile unsigned char *)0xffff8702)
#define DTED	(*(volatile unsigned char *)0xffff8703)
#define DTEE	(*(volatile unsigned char *)0xffff8704)
#define DTCSR	(*(volatile unsigned short *)0xffff8706)
#define DTBR	(*(volatile unsigned short *)0xffff8708)
#define CCR	(*(volatile unsigned short *)0xffff8740)

#define IOTYPE	unsigned short





